// Copyright Neil Cochrane 2006

var snapshotDirName = "./Snapshots/";
var snapshotDir = null;
var PREF_DOUBLE = "double";
var PREF_MUTED = "muted";
var gameIndex = -1;


function snapshot(title, url, desc)
{
  this.title = title;
  this.url = url;
}

function load()
{
	if (window.widget)
	{
      var doubleSize = widget.preferenceForKey(PREF_DOUBLE);
	  if (doubleSize == null)
	    doubleSize = false;
		
	  var doubleCheck = document.getElementById("doublecheck");
	  doubleCheck.checked = doubleSize;
	  doubleClick(); // this will take care of initial sizing
	  
      var muted = widget.preferenceForKey(PREF_MUTED);
	  if (muted == null)
	    muted = false;
		
	  var mutedCheck = document.getElementById("mutedcheck");
	  mutedCheck.checked = muted;
	  
	  sizeWidget(true);
	}
}

function doubleClick()
{
    var doubleCheck = document.getElementById("doublecheck");
	var checked = doubleCheck.checked;
	widget.setPreferenceForKey(checked, PREF_DOUBLE);
}

function sizeWidget(minimize)
{	
    var frontImg = document.getElementById("frontImg");
    var appletdiv = document.getElementById("appletdiv");
	
    var doubleCheck = document.getElementById("doublecheck");
	var checked = doubleCheck.checked;
	
    if (minimize)
	{
	  frontImg.src = "Images/spectrum-small.png";
	}
	else if (checked)
	{
	  window.resizeTo(556,468);
	  appletdiv.width = "512";
	  appletdiv.height = "384";
	  frontImg.src = "Images/spectrumx2.png";
	}
	else
	{
	  window.resizeTo(300,276);
	  appletdiv.width = "256";
	  appletdiv.height = "192";
	  frontImg.src = "Images/spectrum.png";
	}
}


function mutedClick()
{
    var mutedCheck = document.getElementById("mutedcheck");
	widget.setPreferenceForKey(mutedCheck.checked, PREF_MUTED);
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, "your-key");
}

function hide()
{
  var gamePopup = document.getElementById("popup");
  gamePopup.selectedIndex = 0;
  selectSnapshot();
  //	var appletdiv = document.getElementById("appletdiv");
  //	appletdiv.display = "block";
  //	appletdiv.innerHTML = '';
}


function show()
{
  if(window.widget) 
  {
    if (snapshotDir == null)
	{
	  var widgetDir = widget.system("/bin/pwd", null).outputString;
	  widgetDir = widgetDir.substring(0,widgetDir.length-1);
	 // snapshotDir = widgetDir + "/" + snapshotDirName;
	  snapshotDir = snapshotDirName;
	}
	
    var lsString = "/bin/ls " + snapshotDirName;
	var lsStatus = widget.system(lsString, null).status;
	if (lsStatus == 1)
	{
	  // snapshot directory not created
	 }
	 else if (lsStatus == 0)
	 {
	   var lsOutput = widget.system(lsString , null).outputString;
       doneLs(lsOutput, snapshotDir);
 	 }
  }
}

function doneLs(contents, dir)
{
	var genrePopup = document.getElementById("popup");
	genrePopup.options.length = 0;
	genrePopup.options[genrePopup.options.length] = new Option("(No Game)", null);
    while(contents.length > 0)
    {
	  var eIndex = contents.indexOf("\n");
	  if (eIndex == -1)
	    break;
		
	  var optionName = contents.substring(0, eIndex);
	  contents = contents.substring(eIndex + 1);

	  if (optionName.indexOf(".txt") > -1)
	    continue;
	  
	  var optionValue = snapshotDir + "/" + optionName;
	  
	  if (optionValue == null)
	    break;
		
	  var lastDot = optionName.indexOf(".");
	  if (lastDot > -1)
	    optionName = optionName.substring(0,lastDot);
		
	  genrePopup.options[genrePopup.options.length] = new Option(optionName, optionValue);
	}
}

function selectSnapshot()
{
	var gamePopup = document.getElementById("popup");
    var gameText = document.getElementById("gametext");
	var i = gamePopup.selectedIndex;
	var t = gamePopup.options[i].text;
	gameText.innerHTML = t;
	gameText.display = "none";
	
	var appletdiv = document.getElementById("appletdiv");
	var gameURL = gamePopup.options[i].value;
	if (gameURL != "null")
	{
	  sizeWidget(false);
	  changeGame(gameURL);
	}
	else
	{
	  sizeWidget(true);
	  appletdiv.innerHTML = "";
	}
}


function changeGame(gameURL)
{
	try{
        var doubleCheck = document.getElementById("doublecheck");
		var appletdiv = document.getElementById("appletdiv");
        var mutedCheck = document.getElementById("mutedcheck");
		
		muted = (mutedCheck.checked) ? "yes" : "no";
	
	    appletdiv.innerHTML = "";
		
	    if (doubleCheck.checked)
		{
		  appletdiv.innerHTML = '<applet code="Qaop.class" ' + 
                                'name="qaop" ' + 
                                'archive="qaop.jar" ' + 
                                'WIDTH="512" HEIGHT="384"> ' + 
                                '<param name="aspect" value="0"> ' + 
                                '<param name="load" value="'+gameURL+'"> ' + 
                                '<param name="muted" value="'+muted+'"> ' + 
                                '<param name="border" value="0"> ' + 
                                '</applet>';
								
	      var applet = document.getElementById("applet");
	      appletdiv.width = "512";
	      appletdiv.height = "384";
		}
		else
		{
		  appletdiv.innerHTML = '<applet code="Qaop.class" ' + 
                                'name="qaop" ' + 
                                'archive="qaop.jar" ' + 
                                'WIDTH="256" HEIGHT="192"> ' + 
                                '<param name="aspect" value="0"> ' + 
                                '<param name="load" value="'+gameURL+'"> ' + 
                                '<param name="muted" value="'+muted+'"> ' + 
                                '<param name="border" value="0"> ' + 
                                '</applet>';
		  
	      var applet = document.getElementById("applet");
	      appletdiv.width = "256";
    	  appletdiv.height = "192";
		}

		appletdiv.display = "none";
	}catch(error) {
		handle_error(error);
	}
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	var gamePopup = document.getElementById("popup");
	gameIndex = gamePopup.selectedIndex;
		
	var appletdiv = document.getElementById("appletdiv");
	appletdiv.innerHTML = "";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");
	sizeWidget(false);

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	var gamePopup = document.getElementById("popup");
	gamePopup.selectedIndex = gameIndex;
	selectSnapshot();
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function openFolder()
{
  var status = widget.system("/usr/bin/open " + snapshotDir, null).status;
  widget.openApplication('com.apple.Finder');
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}
